{   ADCRTKEYL.PAS - a pascal unit under Linux which contents some higher
      functions and procedurs that use CRT200L (display unit) and KEYL
      (keyboard unit) units.

    Copyright (C) 2002  <Petr Pisar>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details (file "copying").

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Author's address:
      - paper mail     : Petr Pisar
                         Uhercice 53
                         Hermanuv Mestec
                         538 03
                         Czech Republic
      - electronic mail: petr.pisar@seznam.cz
      - web sites      : www.gjr.cz/~pisarp/

}

unit adcrtkeyl;
interface
uses crt200l, keyl;
var
  exit_key :char;
  exit_cti :string;

  procedure setexitcti (seznam_klaves :string);
  procedure cti (vstup_ptr :pointer; sloupek, radek, fyz_max, virt_max :byte);
implementation

procedure setexitcti (seznam_klaves :string);
var
  a :byte;
begin
  exit_cti := seznam_klaves;
end;


procedure cti (vstup_ptr :pointer; sloupek, radek, fyz_max, virt_max :byte);
type
  retezec_ptr = string;  {pripravuji typ pro dynamickou promennou}
var
  {tady si musime nadefinovat dynamickou promennou, abychom ji mohli adresovat
   na 'vstup', jehoz adresa je dana parametrem vstup_ptr}
  retezec : ^ retezec_ptr;        {promenna jako link na 'vstup'}
  original_retezec_ptr : pointer; {originalni adresa 'retezec' - je NUTNA}


  znak :array [0..255] of char; {retezec rozlozeny na jednotlive znaky}
  kurzor :byte;        {souradnice kurzoru}
  fyz_poz :byte;    {absolutni pozice kurzoru v retezci}
  virt_poz :byte;   {virtualni pozice - pocitano od vstup. rad. na obraz.}
  delka :byte;  {delka retezce}
  prepis :boolean;  {znaci zda text vkladat nebo prepisovat}

  konec :boolean; {znacim ze procedura ma zkoncit}
  klavesa :char;
  a, b, z:byte;
begin
  {Nyni musim presmerovat 'retezec' na 'vstup', jinak kdybych pracoval s
   retezcem primo, tak se procedura pri svem ukonceni kousne - na prikazu
   END; - je to velmi divne, zrejme chyba compilatoru Pascalu}
  original_retezec_ptr := retezec;  {ukladam si puvodni adresu}
  retezec := vstup_ptr;             {provadim presmerovani na 'vstup'}

  {nejdrive nejake inicializace, protoze se jedna o proceduru s daty
   na Stacku}
  prepis := false;
  konec := false;
  for a := 0 to 255 do znak [a] := ' ';
  {nastavuji kurzor ma standard}
  kurzor := 0;
  setkurzor (13, 14);

  {nasilim tam cpu nejake hodnoty, protoze to neni dodelany}
  {virt_max se zadava i s okrajema, takze "char" promenna by mela
   virt_max := 3; fyz_max := 1);}
  if (sloupek + fyz_max + 1) > 79 then fyz_max := 78 - sloupek;
  if fyz_max < 1 then fyz_max := 1;
  if virt_max < 3 then virt_max := 3;
  virt_max := fyz_max + 2; {!Tady zatim nutim hodnoty - namam udelanej
                            scrolling}

  {zobrazime vstupni radku - pozor pridava mezeru na oba konce}
  jdina (sloupek, radek);
  for a := 0 to (virt_max - 1) do pisz (' ');

  {korekce zadani - na zacatku a na konci vstup. tad. je dana mezera}
  sloupek := sloupek + 1;
  virt_max := virt_max - 1;

  {nejdrive provedem rozklad retezce}
  delka := length (retezec^);
  if delka <> 0 then for a := 1 to delka do znak [a - 1] := retezec^ [a];
  fyz_poz := delka;
  virt_poz := delka;
  kurzor := delka;
  {zobrazime retezec, poze kdyz ma nenulovou delku, jinak to pise blbosti}
  jdina (sloupek, radek);
  if delka <> 0 then for a := 0 to (delka - 1) do pisz (znak [a]);
  kurzorto (sloupek + kurzor, radek);

  {klavesova smycka}
  repeat
  (*{jemom mensi kontroni vypisy}
    jdina (11, 7);
    for z := 0 to 30 do pisz (znak [z]);

    jdina (0, 10);
    pis ('Klavesa: ' + klavesa);
    jdina (0, 11);
    pis ('Typ klavesy: ');
    pisb (key_type);

    jdina (15, 10);
    pis ('fyz_max: ');
    pisb (fyz_max);

    jdina (15, 11);
    pis ('delka: ');
    pisb (delka);

    jdina (15, 12);
    pis ('fyz_poz: ');
    pisb (fyz_poz);

    jdina (15, 13);
    pis ('kurzor: ');
    pisb (kurzor);
    *)

    {obnovime pozici kurzoru}
    refreshkurzor;

    {cekame az se neco ztiskne}
    repeat
      klavesa := getkey;
    until klavesa <> #0;

    {Esc a Enter na standartniukoceni}
    if (klavesa = #27) or (klavesa = #13) then konec := true;


  if key_type >= 3 then begin
    {Kontroluji seznam klaves pri kterych ma dojit k ukonceni}
    for a := 1 to length (exit_cti) do
      if klavesa = exit_cti [a] then konec := true;

    {Insert}
    if klavesa = #183 then begin
      {kdyz se jiz prepisovalo, cheme opet vkladami - kurzor bude normalni}
      if prepis then begin
        setkurzor (13, 14);
        prepis := false;
      end
      {doted se vkladalo, budeme prepisovat - kurzor bude pres cely znak}
      else begin
        setkurzor (0, 15);
        prepis := true;
      end;
    end;


    {Home}
    if klavesa = #184 then begin
      {zmensime ukazatele pozice na nulu - presuneme se na zacatek}
      fyz_poz := 0;
      virt_poz := 0;
      kurzor := 0;
    end;


    {End}
    if klavesa = #187 then begin
      {zvetsime ukazatele pozice na maximum - na konec}
      fyz_poz := delka;
      virt_poz := delka;
      kurzor := delka;
    end;


    {sipka doleva}
    if klavesa = #190 then begin
      if fyz_poz > 0 then begin
        {zmensime ukazatele pozice}
        fyz_poz := fyz_poz - 1;
        virt_poz := virt_poz - 1;
        kurzor := kurzor - 1;
      end;
    end;


    {sipka doprava}
    if klavesa = #192 then begin
      if kurzor < delka then begin
        {zvetsime ukazatele pozice}
        fyz_poz := fyz_poz + 1;
        virt_poz := virt_poz + 1;
        kurzor := kurzor + 1;
      end;
    end;


    {Delete}
    if klavesa = #186 then begin
      if fyz_poz < delka then begin
        {text za kurzorem posuneme doleva}
        for a := fyz_poz to (delka - 1) do znak [a] := znak [a + 1];
        {vlozime na konec mezeru}
        znak [delka - 1] := ' ';
        delka := delka - 1;
      end;
    end;


    {Backspace}
    if klavesa = #8 then begin
      if fyz_poz > 0 then begin
        {text za kurzorem posuneme doleva}
        if fyz_poz < delka then begin  {jsme-li na konci retezce tak FOR blbne}
          for a := fyz_poz to (delka - 1) do znak [a - 1] := znak [a];
        end
        else begin
          znak [fyz_poz - 1] := ' ';
        end;
        {vlozime na konec mezeru}
        znak [delka - 1] := ' ';
        delka := delka - 1;
        {zmensime ukazatele pozice}
        fyz_poz := fyz_poz - 1;
        virt_poz := virt_poz - 1;
        kurzor := kurzor - 1;
      end;
    end;
  end;

    {klasicke klavesy - pismenka: a d g h a cislice}
    if key_type <= 2 then begin
      {PREPISOVAT - stiskli jsme Ins, bude me prepisovat}
      if prepis then begin
        if fyz_poz < fyz_max then begin
          {na fyz_pozici prepiseme novym znakem ten stary}
          znak [fyz_poz] := klavesa;
          {jsme-li na konci retezce, tak jsme nic neprepsali, ale pridali
           znak na konec. Proto musime v tomto pripade zvetsit 'delka'}
          if fyz_poz = delka then delka := delka + 1;
          {zvetsime ukazatele pozice}
          fyz_poz := fyz_poz + 1;
          virt_poz := virt_poz + 1;
          kurzor := kurzor + 1;
        end;
      end
      {VKLADAT - Ins jsme nestiskli, budeme normalne vkladat}
      else begin
        if delka < fyz_max then begin
          {posuneme text za kurzorem doprava}
          for a := (delka - 1) downto fyz_poz do znak [a + 1] := znak [a];
          {vlozime na fyz_pozici novy znak}
          znak [fyz_poz] := klavesa;
          delka := delka + 1;
          {zvetsime ukazatele pozice}
          fyz_poz := fyz_poz + 1;
          virt_poz := virt_poz + 1;
          kurzor := kurzor + 1;
        end;
      end;
    end;


    {finalni zobrazeni vstup.radky}
    {zobrazim retezec po zmene}
    jdina (sloupek, radek);
    for a := 0 to (virt_max - 1) do pis (znak [a]);
    {zobrazime kurzor na spravne misto}
    kurzorto (sloupek + kurzor, radek)

  until konec;
  kurzoroff; {vypneme kurzor, aby neblikal}
  setkurzor (13, 14);
  {vracime co nam nas "pisar" napsal}
  retezec^ := '';
  if delka <> 0 then
    for a := 0 to (delka - 1) do retezec^ := retezec^ + znak [a];
  {musime zadat exit_key - pro identifikaci, jak procedura zkoncila.
   Zda Enterem nebo Esc, ci jinak}
  exit_key := klavesa;


  {!!!!! - tady musime vratit adresaci promene 'retezec' jinak nam dojde
   k te zahadne chybe - kdo na tu chybu prijde, je fakt dobrej}
  retezec := original_retezec_ptr;
end;


end.
