{   CRT200L.PAS - a free pascal unit under Linux which contents functions
      and procedurs that work with display (It uses standart FreePascal's
      CRT unit)

    Copyright (C) 2002-2003  <Petr Pisar>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details (file "copying").

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Author's address:
      - paper mail     : Petr Pisar
                         Uhercice 53
                         Hermanuv Mestec
                         538 03
                         Czech Republic
      - electronic mail: petr.pisar@seznam.cz
      - web sites      : http://www.fi.muni.cz/~xpisar/
}

unit crt200l;

interface
type 
  rbytemista = record
    x, y :byte;
  end;

  {simulace videopameti konsole}
  tznak = record
    znak :char;
    forground, background :byte;
  end;
  tkonsole = array [0..79, 0..24] of tznak;
  tblok = record
    x, y :byte;  {rozmery bloku}
    d :array [0..1999] of tznak; {samotna data}
  end; 

var
  bytemista :rbytemista;
  kurzor :rbytemista;
  kurzor_status :boolean;  {zda je on/off}
  procedure initcrt;
  procedure shutcrt;

  procedure wait (doba :word);

  procedure barva (popredi, pozadi :byte);
  procedure jdina (xova, yova :byte);

  procedure pisz (znak :char);
  procedure mazej;
  procedure pis (retezec :string);
  procedure pisb (cislo :byte);
  procedure pisw (cislo :word);

  procedure ctiblok (x1, y1, x2, y2 :byte; var datablok: pointer);
  procedure pisblok (x1, y1 :byte; var datablok: pointer; uvolnit :boolean);
  procedure uvolniblok (var datablok: pointer);
  
  procedure kurzorto (x, y :byte);
  procedure refreshkurzor;
  procedure kurzoroff;
  procedure setkurzor (horni, dolni :byte);

  procedure beep;

implementation
uses crt;
type
  tbytebarvy = record
    forground, background :byte;
  end;
 
var
  bytebarvy :tbytebarvy;
  {simulace videpameti konsole}
  konsole :^tkonsole;
procedure initcrt;
begin
  new (konsole);
  jdina (0, 0);
  barva (7, 0);
  mazej;
  kurzorto (0, 0);
  {kurzoroff;}
end;

procedure shutcrt;
begin
  barva (7, 0);
  mazej;
  kurzorto (0, 24);
  dispose (konsole);
end;

{ziska souradnice fyzickeho kurzoru - wherex/y a nastavi na tuto pozici pero}
procedure peroasgotoxy;
var
  x, y :byte;
begin
  bytemista.x := wherex - 1;
  bytemista.y := wherey - 1;
end;

procedure wait (doba :word);
begin
  delay (doba);
end;

procedure barva (popredi, pozadi :byte);
begin
  bytebarvy.forground := popredi;
  bytebarvy.background := pozadi;
  textcolor (bytebarvy.forground);
  textbackground (bytebarvy.background);
end;

procedure jdina (xova, yova :byte);
begin
  {prictemem +1, protoze zadavame fyzicky}
  inc (xova);
  inc (yova);
  {poravname presah}
  if xova >= screenwidth then xova := screenwidth;
  if yova >= screenheight then yova := screenheight;
  {if (yova = screenheight) and (xova = screenwidth) then
    xova := screenwidth - 1;}
  {presuneme pero}
  gotoxy (xova, yova);
  {zapiseme do registru - pozice pera}
  bytemista.x := xova - 1;
  bytemista.y := yova - 1;
end;

procedure mazej;
var
  a, b :byte;
begin
  clrscr;
  for a := 0 to 79 do
    for b := 0 to 24 do begin
      with konsole^ [a, b] do begin
        znak := ' ';
        forground := bytebarvy.forground;
        background := bytebarvy.background;
      end;
    end;  
end;


procedure pisz (znak :char);
var
  delka, a :byte;
begin
  {zapis do virtualni konsole}
  with konsole^ [bytemista.x, bytemista.y] do begin
    znak := ' ';
    forground := bytebarvy.forground;
    background := bytebarvy.background;
  end;
  {zobrazime znak}
  write (znak);
  {posuneme pero}
  inc (bytemista.x);
  if bytemista.x = screenwidth then begin
    if bytemista.y < screenheight - 1 then begin
      bytemista.x := 0;
      inc (bytemista.y);
    end
    else begin 
      dec (bytemista.x);
    {!!! nasledujici radek je nutny i kdyz vypada nesmyslne - v linuxu Crt
    funguje tak, ze kdyz na poslednim sloupku posledniho radku napisi 1 znak,
    tak se zobrazi, ale fyz.kurzor se neposune. Kdyz dam znova write (<char>),
    tak se znak zobrazi na zacatek dalsiho radku. Ale kdyz mezi temito
    2 writy presunu fyz.kurzor pomoci 'gotoxy' nekam jinam, a pak se zase
    vratim na posledni sloupec, tak se 2. write chova jako by byl zase ten 1.
    Takze takhle mohu neustale dokolecka zapisovat na posledni znak displaye
    a nic se mi neodskroluje. Staci mezi 2 'gotoxy + write' vlozit
    'gotoxy (<nekam uplne jinam>)}
      gotoxy  (bytemista.x, bytemista.y + 1);  
    end;
  end;
  {peroasgotoxy;}
  {posuneme fyz.kurzor}
  gotoxy (bytemista.x + 1, bytemista.y + 1);  
end;

procedure pis (retezec :string);
var
  delka, puv_pero_x, a :byte;
  zbyva_mista :word;
  ret :string;
begin
  ret := retezec;
  {zkratime delku retzece tak, aby nepresahoval pres radek}
  {delka := length (ret);
  if bytemista.x + delka > screenwidth then begin
    delka := screenwidth - bytemista.x;
    byte (ret [0]) := delka;
  end;}
  {zkratime delku retzece tak, aby nepresahoval posledni radek displaye, a
   tak neodskroloval obrazovku}
  delka := length (ret);
  a := screenheight - 1 - bytemista.y;
  zbyva_mista := a shl 6 + a shl 4 + (screenwidth - bytemista.x);
  if delka > zbyva_mista then begin
    delka := zbyva_mista;
    byte (ret [0]) := delka;
  end;

  {zapis do virtualni konsole}
  for a := 1 to delka do begin
    with konsole^ [bytemista.x, bytemista.y] do begin
      znak := ret [a];
      forground := bytebarvy.forground;
      background := bytebarvy.background;
    end;

    {posuneme pero o 1 znak}
    inc (bytemista.x);
    if bytemista.x = screenwidth then begin
      bytemista.x := 0;
      inc (bytemista.y);
    end;  
  end;

  {zobrazime retezec}
  write (ret);

  {presuneme fyzicky kurzor - standartni fce write totiz blbne - skonci-li
   retezec presne na konci radku, tak fyz. kurzor zustane na jeho konci (tzn.
   na poslednim pismeni na poslednim sloupci. Dalsim volani 'write' zobrazi
   1. znak na 1. sloupec nasledujiciho radku, ALE 2. znak na 1.sloupec
   dalsiho radku. - proto jsem zavrhnul ziskavani pozice pera z 'wherex/y' a
   delam to rucne. Zrovna tak koriguji pozici fyz.kurzoru}
  if bytemista.y = screenheight then begin
    dec (bytemista.y);
    bytemista.x := screenwidth - 1;
    gotoxy (bytemista.x, bytemista.y + 1);
  end;
  gotoxy (bytemista.x + 1, bytemista.y + 1);
end;

procedure pisw (cislo :word);
var 
  s :string;  
begin
  str (cislo, s);
  pis (s);
end;

procedure pisb (cislo :byte);
begin
  pisw (cislo);
end;

{souradnice jsou fyzicke}
procedure ctiblok (x1, y1, x2, y2 :byte; var datablok: pointer);
var
  delka :word;
  pblok :^tblok;

  zac :word;
  a, b, i, d :word;
  p :byte;
begin
  {kontrola souradnic}
  if x1 > x2 then begin
    p := x2;
    x2 := x1;
    x1 := p;
  end;
  if y1 > y2 then begin
    p := y2;
    y2 := y1;
    y1 := p;
  end;
  {vypocitavam rozmery}
  delka := (x2 - x1 + 1) * (y2 - y1 + 1);

  {alokuji potrebnou pamet}
  pblok := nil;
  getmem (pblok, sizeof (tznak) * delka + 2 * sizeof (byte));
  datablok := pblok;
  
  {ukladam rozmery}
  pblok^.x := x2 - x1 + 1;
  pblok^.y := y2 - y1 + 1;
  
  {kopiruji}
  i := 0;
  for b := y1 to y2 do 
    for a := x1 to x2 do begin
      pblok^.d[i].znak := konsole^[a, b].znak;
      pblok^.d[i].forground := konsole^[a, b].forground;
      pblok^.d[i].background := konsole^[a, b].background;
      inc (i);
    end;
end;

procedure uvolniblok (var datablok: pointer);
var
  delka :word;
  pblok :^tblok;
begin
  if datablok <> nil then begin
    pblok := datablok;
    delka := pblok^.x * pblok^.y;
    freemem (pblok, sizeof (tznak) * delka + 2 * sizeof (byte));
    pblok := nil;
    datablok := pblok;
  end;
end;

procedure pisblok (x1, y1 :byte; var datablok: pointer; uvolnit :boolean);
var
  delka :word;
  pblok :^tblok;
  x2, y2 :byte;

  zac :word;
  a, b, i :word;
begin
  pblok := datablok;
  {nacitam rozmery}
  x2 := x1 + pblok^.x - 1;
  y2 := y1 + pblok^.y - 1; 

  {zobrazuji blok}
  i := 0;
  for b := y1 to y2 do begin
    {nastavuji fyz.kurzor na 1. sloupec bloku}
    gotoxy (x1 + 1, b + 1);
    for a := x1 to x2 do begin
      {kopiruji z bloku do konsole}  
      konsole^[a, b].znak := pblok^.d[i].znak;
      konsole^[a, b].forground := pblok^.d[i].forground;
      konsole^[a, b].background := pblok^.d[i].background;
      {zobrazuji dany znak}
      textcolor (pblok^.d[i].forground);
      textbackground (pblok^.d[i].background);
      write (pblok^.d[i].znak);
      inc (i);
    end;
  end;
  {uvolnuji pamet}
  if uvolnit then uvolniblok (pblok);
  datablok := pblok;
end;


procedure kurzorto (x, y :byte);
begin
  {prictemem +1, protoze zadavame fyzicky}
  inc (x);
  inc (y);
  {poravname presah}
  if x > screenwidth then x := screenwidth;
  if y > screenheight then y := screenheight;
  {if (y = screenheight) and (x = screenwidth) then
    x := screenwidth - 1;}
  {presuneme kurzor}
  gotoxy (x, y);
  {zapiseme do registru - pozice kurzoru}
  kurzor.x := x - 1;
  kurzor.y := y - 1;
  {zmenime stav}
  kurzor_status := true;
end;

procedure refreshkurzor;
begin
  if kurzor_status then gotoxy (kurzor.x + 1, kurzor.y + 1)
  else gotoxy (0, 0);
end;
procedure kurzoroff;
begin
  gotoxy (0, 0);  {v konzoli linuxu kurzor vypnout nejde}
  kurzor_status := false;
end;

{tvar kuzoru:
        radek cislo 0 --- horni
                      ---
                      ---
                      ---
                      ---
                   15 --- dolni }

procedure setkurzor (horni, dolni :byte);
begin
{  asm
    mov ah, 01H
    mov ch, horni
    mov cl, dolni
    int 010H
  end;}
end;

procedure beep;
begin
  sound (400);
  delay (100);
  nosound;
end;

end.
