unit tui;

interface
type
  pmenu_list = ^tmenu_list;
  tmenu_akce = procedure;
  tmenu_item = record
    title :string [64];
    hint :string [9];
    action :tmenu_akce;
    psubmenu_list :pmenu_list;
    end;
  tmenu_list = record
    count :byte;
    item :array [0..25] of tmenu_item;
    end;
const
  {okna}
  nid :byte = 0;  {new_window}
  root :byte = 255; {root_window}
  center :byte = 255; {znaci, ze vycentrujeme okno}
var
  {okna}
  aid :byte;
  {aktip}
  exit_key :char;



procedure inittui;
procedure shuttui;

function  i2s (cislo :integer) :string;
procedure cekej (doba :word);

procedure openwindow (var id :byte);
procedure closewindow (id :byte);
procedure changewindow (id :byte);

procedure swhasborder (id :byte; whf :boolean);
procedure swsize (id :byte; width, height :byte);
procedure swposition (id :byte; x, y :byte);
procedure swcenter (id :byte);
procedure swtitle (id :byte; title :string);
procedure swcolor (fg, bg :byte);
procedure swborder (lh, ph, ld, pd, v, s :char);

procedure wjdina (nx, ny :byte);
procedure wbarva (fg, bg :byte);
procedure wpis (ret :string);
procedure wpisz (z :char);
procedure wpisw (w :word);

procedure wmazej;
procedure wkurzorto (sl, ra :byte);
procedure wrefreshkurzor;
procedure wkurzoroff;

procedure addbutton (bx, by :byte; btitle :string); 
procedure addinputline (bx, by :byte; vstup_ptr :pointer;
			fyz_max, virt_max :byte);
procedure addlist (var s_t :array of string[4]);
function runaktip (start :byte) :byte;
procedure setexitkey (ret :string);
procedure setallowedkey (ret: string);
procedure setdisallowedkey (ret: string);
procedure setfromctitonextallow (p :boolean);  
procedure setbuttondecoration (l, p :char);
procedure setbuttoncolor (pfg, pbg, afg, abg :byte);
procedure setinputlinecolor (pfg, pbg, afg, abg :byte);

procedure menuitem (var pml :pmenu_list; title :string[64]; hint :string[5];
                    action :tmenu_akce);
function submenu (var pml :pmenu_list; title :string[64]): pmenu_list;
procedure justifynewmenuitem (pml :pmenu_list);
procedure freemenu (var pml :pmenu_list);
function runmenu (mlist :pmenu_list; start :byte) :boolean;
procedure setmenucolor (ptfg, phfg, pbg, atfg, ahfg, abg :byte);


implementation

uses crt200l, keyl;
type
  taktip = record
    x, y :byte;   	{umistneni}
    case typ: byte of 
      {button}
      0: (title :string);
      {inputline}
      1: (vstup_ptr :pointer; fyz_max, virt_max :byte;
          allowed_key_list, disallowed_key_list :string);
    end;
  paktip = ^taktip;

  twindow = record
    id :byte;
    has_border :boolean;
    title :string;
    pozadi :pointer;
    
    rfg, rbg :byte;       {barvy ramu}
    
    
    width, height :byte;  {rozmery okna jsou rozmery vnitrni plochy bez ramu}
    wx1, wy1 :byte;       {souradnice plochy okna bez ramu}
    wx2, wy2 :byte;

    x, y :byte;           {pointer zobrazovaci a barvy v okne}
    {kurzor_x, kurzor_y :byte} {hardwarovy kurzorv okne}
    fg, bg :byte;

    {aktivni prvky}
    aktip :array [0..31] of paktip;
    poc_aktip :byte;
  end;
  pwindow = ^twindow;

const
  {plocha - root okno id=0}
  root_width :byte = 80;
  root_height :byte = 25;
  root_x_max :byte = 79;
  root_y_max :byte = 24; 


var
  {okna}
  sez_oken :array [0..255] of pwindow;
  poc_oken :byte;
  new_window, akt_window, root_window :pwindow;
  {aid :byte;}
  {oramovani-dekorace oken}
  rlh, rph, rld, rpd, rv, rs :char;
  {barvy okna}
  rfg, rbg :byte;

  {hardwarovy kurzor se udava vzhledem k root_oknu}
  kurzor_x, kurzor_y :byte;

  {aktivni prvky}
  exit_key_list :string;
  {inputline}
  from_cti_to_next_allow :boolean;
  allowed_key_list, disallowed_key_list :string;
  {dekorace tlacitek}
  bl, bp :char;
  {barvy tlacitek}
  bafg, babg :byte;	{aktivni}
  bpfg, bpbg :byte;	{pasivni}
  {barvy inputline}
  iafg, iabg, ipfg, ipbg :byte;
  
  {menu}
  mptfg, mphfg, mpbg :byte; {pasivni - popredi title, popredi hint, pozadi sp.}
  matfg, mahfg, mabg :byte; {aktivni}  

procedure initaktip;
begin
  {tlacitka}
  setbuttondecoration ('<', '>');
  setbuttoncolor (7,1,1,7);
  {inputline}
  setfromctitonextallow (true);
  setinputlinecolor (7,0,0,7);
end;

procedure initmenu;
begin
  setmenucolor (0, 4, 7, 7, 4, 2);
  {mptfg := 0;
  mphfg := 4;
  mpbg := 7;
  matfg := 7;
  mahfg := 4;
  mabg := 2;}
end;

procedure inittui;
var
  a :byte;
begin
  initcrt;
  initkeyl;

  poc_oken := 0;
  for a := 1 to 255 do sez_oken [a] := nil;
  {defaultni okno pro nastaveni}
  new (new_window);
  sez_oken [0] := new_window;
  {root okno - id = 255}
  new (root_window);
  sez_oken[255] := root_window;
  with root_window^ do begin
    wx1 := 0;
    wy1 := 0;
    wx2 := 79;
    wy2 := 24;
    width := 80;
    height := 25;
    has_border := false;
  end;
  

  {defaultni okno po inicializaci je root_window}
  akt_window := root_window{new_window};
  aid := root;
  wbarva (7, 0);
  wjdina (0, 0);

  {defaulrni hodnoty}
  swcolor (7, 0);
  swborder ('+', '+', '+', '+', '-', '|');
  swhasborder (nid, true);
  initaktip;
  initmenu;
  wkurzorto (0, 0);
end;

procedure shuttui;
var
  a :byte;
begin
  akt_window := nil;
  dispose (new_window);
  dispose (root_window);
  sez_oken [0] := new_window;
  sez_oken[255] := root_window;

  for a := 254 downto 1 do
    if sez_oken [a] <> nil then closewindow (a);
   
  shutkeyl;
  shutcrt;
end;

function i2s (cislo :integer) :string;
begin
  str (cislo, i2s);
end;

procedure cekej (doba :word);
begin
  wait (doba);
end;

procedure drawborder (id :byte);
var
  prac_okno :pwindow;
  ret :string;
  a, b :byte;
begin
  prac_okno := sez_oken [id];
  with prac_okno^ do begin
    barva (rfg, rbg);
    jdina (wx1-1, wy1-1);
    pis (rlh);  {levy horni roh}
    for a := 1 to width do pis (rv);    {horni linka}
    pis (rph);  {pravy horni roh}
    for a := 1 to height do begin       
      jdina (wx1-1, wy1 + a - 1);
      pis (rs);  {leva linka}
      for b := 1 to width do pis (' ');  {plocha okna}
      pis (rs);  {prava linka}
    end;
    jdina (wx1-1, wy1 + height);
    pis (rld);   {levy dolni roh}
    for a := 1 to width do pis (rv);     {dolni linka}
    pis (rpd);   {pravy dolni roh}
    
    {titulek}
    ret := title;
    if length (ret) > 0 then begin
      if length (ret) > width then ret[0] := char (width);
      if length (ret) + 2 <= width then ret := ' ' + ret + ' ';
      a := (width - length (ret)) div 2;
      jdina (wx1 + a, wy1 - 1); 
      pis (ret);
    end;
  end;
end;

procedure openwindow (var id :byte);
var
  prac_okno :pwindow;
  a, b :byte;
begin
  if poc_oken < 255 then begin
    {najdeme volne 'id'}
    a := 1;
    while (sez_oken[a] <> nil) do inc (a);
    id := a;

    {naalokujeme nove okno}
    aid := id; 
    akt_window := nil;
    new (akt_window);
    sez_oken [aid] := akt_window;
    inc (poc_oken);

    prac_okno := sez_oken [aid];


    {nakonfigurujeme okno}
    prac_okno^ := sez_oken[0]^;  
    prac_okno^.rfg := rfg;
    prac_okno^.rbg := rbg;
    with prac_okno^ do begin
      if has_border then begin      {okno ma ramecek}
        if wx1 < 1 then wx1 := 1;
        if wy1 < 1 then wy1 := 1;
        {nacteme pozadi}
        ctiblok (wx1-1, wy1-1, wx1+width, wy1+height, pozadi);
        {vykreslime okno}
        drawborder (aid);
      end
      else begin    {okno je bez ramce}
        ctiblok (wx1, wy1, wx1+width-1, wy1+height-1, pozadi);
        barva (rfg, rbg);
        for a := wy1 to wy1+height-1 do begin
	  jdina (wx1, a);
	  for b := wx1 to wx1+width-1 do pisz (' ');
	end;
      end;

      {nastavime implicitni hodnoty}
      x := 0;
      y := 0;
      jdina (wx1, wy1);
      fg := rfg;
      bg := rbg;
      poc_aktip := 0;
    end;
  end;
end;

procedure closewindow (id :byte);
var
  prac_okno :pwindow;
  a :byte;
begin
  if (sez_oken[id] <> nil) and (sez_oken[id] <> root_window) then begin
    prac_okno := sez_oken [id];
    with prac_okno^ do 
      if has_border then pisblok (wx1 - 1, wy1 - 1, pozadi, true)
      else pisblok (wx1, wy1, pozadi, true);
    dispose (prac_okno);
    sez_oken [id] := nil;
    dec (poc_oken);
    {prepneme se na nejake predesle okno}
    a := id;
    while (sez_oken [a] = nil) and (a > 0) do dec (a);
    if poc_oken > 0 then changewindow (a) {prepneme se na normalni okno}
    else changewindow (root);  {prepneme se na root okno}
  end;
end;

procedure changewindow (id :byte);
begin
  if sez_oken [id] <> nil then begin
    aid := id;
    with sez_oken [aid]^ do begin
      wbarva (fg, bg);
      wjdina (x, y);
    end;
  end;
end;

procedure swhasborder (id :byte; whf :boolean);
begin
  sez_oken[id]^.has_border := whf;
end;

procedure swsize (id :byte; width, height :byte);
var
  prac_okno :pwindow;
begin
  prac_okno := sez_oken [id];
  prac_okno^.width := width;
  prac_okno^.height := height;
end;

procedure swposition (id :byte; x, y :byte);
var
  prac_okno :pwindow;
begin
  prac_okno := sez_oken [id];
  {umistime horizontalne}
  if x <> center then prac_okno^.wx1 := x
  else prac_okno^.wx1 := ((root_width - prac_okno^.width - 2) div 2) + 1;
  {umistime vertikalne}  
  if y <> center then prac_okno^.wy1 := y
  else prac_okno^.wy1 := ((root_width - prac_okno^.height - 2) div 2) + 1;
end;

procedure swcenter (id :byte);
var
  prac_okno :pwindow;
begin
  prac_okno := sez_oken [id];
  prac_okno^.wx1 := ((root_width - prac_okno^.width - 2) div 2) + 1;
  prac_okno^.wy1 := ((root_height - prac_okno^.height - 2) div 2) + 1;
end;

procedure swtitle (id :byte; title :string);
var
  prac_okno :pwindow;
begin
  prac_okno := sez_oken [id];
  prac_okno^.title := title;

  {uzivatel redefinuje existijici okno}
  if id <> 0 then begin
  end;
end;

procedure swcolor (fg, bg :byte);
begin
  rfg := fg;
  rbg := bg;
end;

procedure swdefaultcolor (fg, bg :byte);
begin
  rfg := fg;
  rbg := bg;
end;

procedure swborder (lh, ph, ld, pd, v, s :char);
begin
  rlh := lh;
  rph := ph;  
  rld := ld;
  rpd := pd;
  rv  := v;
  rs  := s;
end;


procedure wjdina (nx, ny :byte);
var
  prac_okno :pwindow;
begin
  prac_okno := sez_oken [aid];
  with prac_okno^ do begin
    if nx > width then x := width
    else x := nx;
    if ny > height then y := height
    else y := ny;
    jdina (wx1+x, wy1+y);
  end;
end;

procedure wpis (ret :string);
var
  prac_okno :pwindow;
begin
  prac_okno := sez_oken [aid];
  with prac_okno^ do begin
    if x + length(ret) > width then ret[0] := char (width-x);
    pis (ret); 

    x := x + length (ret);
    if x >= width then 
      if y < height then begin
        x := 0;
        inc (y)
      end
      else dec (x);
    jdina (wx1+x, wy1+y);
  end;
end;

procedure wpisz (z :char);
begin
  with sez_oken [aid]^ do begin
    if x < width then begin 
      pisz (z);
      inc (x);
      if x >= width then
        if y < height then begin
	  x := 0;
	  inc (y);
	end
	else dec (x);	
      jdina (wx1+x, wy1+y);  
    end;
  end;
end;

procedure wpisw (w :word);
begin
  wpis (i2s (w));
end;

procedure wmazej;
var
  prac_okno :pwindow;
  a, b :byte;
begin
  prac_okno := sez_oken[aid];
  with prac_okno^ do begin
    wjdina (0, 0);
    for a := 0 to height-1 do 
      for b := 0 to width-1 do
        wpis (' ');
   wjdina (0, 0);	
  end;
end;

procedure wbarva (fg, bg :byte);
var
  prac_okno :pwindow;
begin
  prac_okno := sez_oken [aid];
  prac_okno^.fg := fg;
  prac_okno^.bg := bg;
  barva (fg, bg);
end;

procedure wkurzorto (sl, ra :byte);
var
   prac_okno :pwindow;
begin
   prac_okno := sez_oken [aid];
   with prac_okno^ do begin
     kurzorto (wx1+sl, wy1+ra);  
     {!!! ZDE JE NUTNE HLIDAT KURZOR, PRI PORTU DO DOSU SE MUSI PREPSAT}
     {wjdina (wx1 + sl, wy1 + ra);}   
   end;
end;

procedure wrefreshkurzor;
begin
  refreshkurzor;
end;

procedure wkurzoroff;
begin
  kurzoroff;
end;

{SEKCE AKTIP}

procedure drawbutton (a :byte; aktivne :boolean);
var
  prac_okno :pwindow;
begin
  prac_okno := sez_oken [aid];
  with prac_okno^.aktip[a]^ do begin
    wjdina (x, y);
    if aktivne then barva (bafg, babg)
    else barva (bpfg, bpbg);
    wpis (bl + title + bp);
  end;
end;

procedure addbutton (bx, by :byte; btitle :string);
var
  prac_okno :pwindow;
begin
  prac_okno := sez_oken [aid];
  with prac_okno^ do begin
    new (aktip [poc_aktip]);

    {wjdina (bx, by);
    barva (bpfg, bpbg);
    wpis (bl + btitle + bp);}

    aktip[poc_aktip]^.x := bx;
    aktip[poc_aktip]^.y := by;  
    aktip[poc_aktip]^.typ := 0; {button}
    aktip[poc_aktip]^.title := btitle;
   
    drawbutton (poc_aktip, false);
  
    inc (poc_aktip);
  end;
end;

procedure drawinputline (a :byte);
var
  prac_okno :pwindow;
  ret :^string;
begin
  prac_okno := sez_oken [aid];
  with prac_okno^.aktip[a]^ do begin
    ret := vstup_ptr;
    barva (ipfg, ipbg);
    wjdina (x, y);
    for a := 1 to virt_max do wpis (' ');
    wjdina (x+1, y);
    a := 1;
    while (a <= virt_max-2) and (a <= length (ret^)) do begin
      wpis (ret^[a]);
      inc (a);
    end;
  end;
end;

procedure addinputline (bx, by :byte; vstup_ptr :pointer;
                        fyz_max, virt_max :byte);
var
  prac_okno :pwindow;
  ret :^string;
  a :byte;
begin
  prac_okno := sez_oken [aid];
  with prac_okno^ do begin
    new (aktip [poc_aktip]);

    aktip[poc_aktip]^.x := bx;
    aktip[poc_aktip]^.y := by;  
    aktip[poc_aktip]^.typ := 1; {inputline}
    aktip[poc_aktip]^.vstup_ptr := vstup_ptr;
    aktip[poc_aktip]^.fyz_max := fyz_max;
    aktip[poc_aktip]^.virt_max := virt_max;
    aktip[poc_aktip]^.allowed_key_list := allowed_key_list;
    aktip[poc_aktip]^.disallowed_key_list := disallowed_key_list;
    
    drawinputline (poc_aktip);
    
    inc (poc_aktip);
  end;
end;                        

procedure cti (vstup_ptr :pointer; sloupek, radek, fyz_max, virt_max :byte;
               allowed_key_list, disallowed_key_list :string);
type
  retezec_ptr = string;  {pripravuji typ pro dynamickou promennou}
var
  {tady si musime nadefinovat dynamickou promennou, abychom ji mohli adresovat
   na 'vstup', jehoz adresa je dana parametrem vstup_ptr}
  retezec : ^ retezec_ptr;        {promenna jako link na 'vstup'}
  original_retezec_ptr : pointer; {originalni adresa 'retezec' - je NUTNA}


  znak :array [0..255] of char; {retezec rozlozeny na jednotlive znaky}
  kurzor :byte;        {souradnice kurzoru}
  fyz_poz :byte;    {absolutni pozice  v retezci}
  virt_poz :byte;   {virtualni pozice - od posunu}
  posun :byte;       {odscrollovan zacatek}
  delka :byte;       {delka retezce}
  prepis :boolean;  {znaci zda text vkladat nebo prepisovat}
  scrollovat :boolean; {povoluje scrolling, napr. je-li (fyz_max+2 < virt_max)}
  povolena_klavesa :boolean; {zda znak je v povolene mnozine znaku}

  konec :boolean; {znacim ze procedura ma zkoncit}
  klavesa :char;
  a, b, z:byte;
  prac_okno :pwindow;
begin
  prac_okno := sez_oken [aid];
  {Nyni musim presmerovat 'retezec' na 'vstup', jinak kdybych pracoval s
   retezcem primo, tak se procedura pri svem ukonceni kousne - na prikazu
   END; - je to velmi divne, zrejme chyba compilatoru Turbo Pascalu}
  original_retezec_ptr := retezec;  {ukladam si puvodni adresu}
  retezec := vstup_ptr;             {provadim presmerovani na 'vstup'}

  {nejdrive nejake inicializace, protoze se jedna o proceduru s daty
   na Stacku}
  prepis := false;
  konec := false;
  for a := 0 to 255 do znak [a] := ' ';
  {nastavuji kurzor ma standard}
  kurzor := 0;
  setkurzor (13, 14);

  {virt_max se zadava i s okrajema, takze "char" promenna by mela
   virt_max := 3; fyz_max := 1);}
  {test rozsahu}
  if (sloupek + virt_max) > 80 then virt_max := 80 - sloupek;
  if virt_max < 3 then virt_max := 3;
  if fyz_max > 254 then fyz_max := 254;
  if fyz_max < 1 then fyz_max := 1;
  {uz me nezajimaji okraje}
  virt_max := virt_max - 2;
  {maxy snizim o 1, protoze neni to delka, ale pozice}
  dec (fyz_max);
  dec (virt_max);
  {povoluji scrolling}
  if fyz_max > virt_max then scrollovat := true
  else scrollovat := false;
  posun := 0;

  {zobrazime vstupni radku - pozor pridava mezeru na oba konce}
  wbarva (iafg, iabg);
  wjdina (sloupek, radek);
  for a := 0 to (virt_max + 2) do wpis (' ');

  {korekce zadani - na zacatku a na konci vstup. rad. je dana mezera}
  inc (sloupek);
  
  {nejdrive provedem rozklad retezce}
  delka := length (retezec^);
  if delka <> 0 then for a := 1 to delka do znak [a - 1] := retezec^ [a];
  if delka > 254 then delka := 254;
  fyz_poz := delka;
  virt_poz := delka;
  kurzor := delka;
  if (delka > virt_max) and scrollovat then begin
    fyz_poz := 0;
    virt_poz := 0;
    kurzor := 0;
  end; 
  
  {zobrazime retezec, pouze kdyz ma nenulovou delku, jinak to pise blbosti}
  wjdina (sloupek, radek);
  if delka <> 0 then for a := 0 to virt_max do wpis (znak [a]);
  wkurzorto (sloupek + kurzor, radek);

  {klavesova smycka}
  repeat
  (*{jemom mensi kontroni vypisy}
    jdina (11, 7);
    for z := 0 to 30 do pisz (znak [z]);

    jdina (0, 10);
    pis ('Klavesa: ' + klavesa);
    jdina (0, 11);
    pis ('Typ klavesy: ');
    pisb (key_type);

    jdina (15, 10);
    pis ('fyz_max: ');
    pisb (fyz_max);

    jdina (15, 11);
    pis ('delka: ');
    pisb (delka);

    jdina (15, 12);
    pis ('fyz_poz: ');
    pisb (fyz_poz);

    jdina (15, 13);
    pis ('kurzor: ');
    pisb (kurzor);
    *)

    {obnovime pozici kurzoru}
    wrefreshkurzor;

    {cekame az se neco stiskne}
    repeat
      klavesa := getkey;
    until klavesa <> #0;

    {Esc a Enter na standartniukoceni}
    if (klavesa = #27) or (klavesa = #13) then konec := true;
    {sipky nahoru, dolu a tab, kdyz je povolen na presun na jinou polozku}
    if from_cti_to_next_allow then 
      if (klavesa = #9) or (klavesa = #189) or (klavesa = #191) then
        konec := true;


  if key_type >= 3 then begin
    {Kontroluji seznam klaves pri kterych ma dojit k ukonceni}
    for a := 1 to length (exit_key_list) do
      if klavesa = exit_key_list [a] then konec := true;

    {Insert}
    if klavesa = #183 then begin
      {kdyz se jiz prepisovalo, cheme opet vkladami - kurzor bude normalni}
      if prepis then begin
        setkurzor (13, 14);
        prepis := false;
      end
      {doted se vkladalo, budeme prepisovat - kurzor bude pres cely znak}
      else begin
        setkurzor (0, 15);
        prepis := true;
      end;
    end;


    {Home}
    if klavesa = #184 then begin
      {presuneme vse na zacatek}
      fyz_poz := 0;
      virt_poz := 0;
      kurzor := 0;
      posun := 0;
    end;


    {End}
    if klavesa = #187 then begin
      {zvetsime ukazatele pozice na maximum - na konec}
      fyz_poz := delka;
      if not scrollovat then begin {scrollovani zakazano}
        virt_poz := delka;
        kurzor := delka;
      end
      else begin  {scrollovani povoleno}
        if fyz_poz < virt_max then begin {konec je uvnitr radku}
          virt_poz := delka;
	  kurzor := delka;
          posun := 0;
        end
	else begin        {konec je za radkem, musime odscrollovat}
	  virt_poz := virt_max;
	  kurzor := virt_max;
          posun := fyz_poz - virt_max;
        end;
      end;
    end;


    {sipka doleva}
    if (klavesa = #190) and (fyz_poz > 0) then begin
      {zmensime ukazatele pozice}
      dec (fyz_poz);
      {scrollovat nemusime}
      if virt_poz > 0 then begin
        dec (virt_poz);
        dec (kurzor);
      end
      {budeme scrollovat}
      else begin
        dec (posun);
      end;
    end;


    {sipka doprava}
    if (klavesa = #192) and (fyz_poz < delka) then begin
      {zvetsime ukazatele pozice}
      inc (fyz_poz);
      {nemusime scrollovat - jsme uvnitr radky}
      if virt_poz < virt_max then begin
        inc (virt_poz);
        inc (kurzor);
      end
      {budeme scrollovat - jsme na kraji radky}
      else begin
        if scrollovat then inc (posun)
	else begin  {scroll. zakazan -> vystrcime kurzor za radku}
	  inc (virt_poz);
	  inc (kurzor);
	end;
      end;
    end;


    {Delete}
    if klavesa = #186 then begin
      if fyz_poz < delka then begin
        {text za kurzorem posuneme doleva}
        for a := fyz_poz to (delka - 1) do znak [a] := znak [a + 1];
        {vlozime na konec mezeru}
        znak [delka - 1] := ' ';
        dec (delka);
      end;
    end;


    {Backspace}
    if klavesa = #8 then begin
      if fyz_poz > 0 then begin
        {text za kurzorem posuneme doleva}
        if fyz_poz < delka then begin  {jsme-li na konci retezce tak FOR blbne}
          for a := fyz_poz to (delka - 1) do znak [a - 1] := znak [a];
        end
        else begin
          znak [fyz_poz - 1] := ' ';
        end;
        {vlozime na konec mezeru}
        znak [delka - 1] := ' ';
        dec (delka);

        {zmensime ukazatele pozice}
        dec (fyz_poz);
        {scrollovat nemusime}
        if virt_poz > 0 then begin
          dec (virt_poz);
          dec (kurzor);
        end
        {budeme scrollovat}
        else begin
          dec (posun);
        end;
      end;
    end;
  end;

  {klasicke klavesy - pismenka: a d g h a cislice}
  if key_type <= 2 then begin
    {zkontrolujeme povolene klavesy}
    povolena_klavesa := true;
    if length (allowed_key_list) > 0 then begin
      a := 1;
      while (a <= length(allowed_key_list)) and (allowed_key_list[a] <> klavesa)
        do inc (a);
      if allowed_key_list[a] <> klavesa then povolena_klavesa := false;
    end;
    {zkontrolujeme zakazane klavesy}
    if length (disallowed_key_list) > 0 then begin
      a := 1;
      while (a <= length (disallowed_key_list)) and
            (disallowed_key_list[a] <> klavesa) do inc (a);
      if disallowed_key_list[a] = klavesa then povolena_klavesa := false;
    end;
    if povolena_klavesa then 
      {PREPISOVAT - stiskli jsme Ins, bude me prepisovat}
      if prepis then begin
        if fyz_poz <= fyz_max then begin
          {na fyz_pozici prepiseme novym znakem ten stary}
          znak [fyz_poz] := klavesa;
          {jsme-li na konci retezce, tak jsme nic neprepsali, ale pridali
           znak na konec. Proto musime v tomto pripade zvetsit 'delka'}
          if fyz_poz = delka then inc (delka);
          {zvetsime ukazatele pozice}
          inc (fyz_poz);
          inc (virt_poz);
          inc (kurzor);
	  {scrolling}
          if (virt_poz > virt_max) and (scrollovat) then begin
            inc (posun);
            dec (virt_poz);
            dec (kurzor);
          end;
        end;
      end
      {VKLADAT - Ins jsme nestiskli, budeme normalne vkladat}
      else begin
        if delka-1 < fyz_max then begin
          {posuneme text za kurzorem doprava}
          for a := (delka - 1) downto fyz_poz do znak [a + 1] := znak [a];
          {vlozime na fyz_pozici novy znak}
          znak [fyz_poz] := klavesa;
          inc (delka);
          {zvetsime ukazatele pozice}
          inc (fyz_poz);
          inc (virt_poz);
          inc (kurzor);
	  {scrolling}
          if (virt_poz > virt_max) and (scrollovat) then begin
            inc (posun);
            dec (virt_poz);
            dec (kurzor);
          end;
        end;
      end;
  end;


    {finalni zobrazeni vstup.radky}
    {zobrazim retezec po zmene}
    wjdina (sloupek, radek);
    for a := 0 to virt_max do wpis (znak [posun + a]);
    {zobrazime kurzor na spravne misto}
    wkurzorto (sloupek + kurzor, radek)

  until konec;

  setkurzor (13, 14); {obnovime jeho velikost na nizky}
  wkurzoroff; {vypneme kurzor, aby neblikal}
    
  {vracime co nam nas uzivatel napsal}
  retezec^ := '';
  if delka <> 0 then
    for a := 0 to (delka - 1) do retezec^ := retezec^ + znak [a];
  {musime zadat exit_key - pro identifikaci, jak procedura zkoncila.
   Zda Enterem nebo Esc, ci jinak}
  exit_key := klavesa;

  {!!!!! - tady musime vratit adresaci promene 'retezec' jinak nam dojde
   k te zahadne chybe - kdo na tu chybu prijde, je fakt dobrej}
  retezec := original_retezec_ptr;
end;

procedure addlist (var s_t :array of string[4]);
var
  a : byte;
begin
  wpis (i2s(high (s_t)));
  for a := 0 to high (s_t) do begin
    wjdina (0, 15 + a);
    wpis (s_t [a] + ';');
  end;
  wpis (s_t [1]);
end;

{funkce spousti formular aktivnich prvky. Prvni prvek po zpusteni je oznacen
 parametrem 'start', vraci cislo prvku, na kterem jsme zkoncili. Navratova
 klavesa je vracena v globalni promenne 'exit_key'}
function runaktip (start :byte) :byte;
var
  konec :boolean;
  klav :char;
  a, prev :byte;
  prac_okno :pwindow;
  b :byte;
begin
  prac_okno := sez_oken [aid];
  with prac_okno^ do begin
    konec := false;
    if start >= poc_aktip then start := poc_aktip - 1;
    a := start;
    prev := a;
    repeat
      {zhasneme predchozi prvek}
      if aktip[prev]^.typ = 0 then drawbutton (prev, false)
      else drawinputline (prev);
      {spustime aktualni prvek}
      if aktip[a]^.typ = 0 then begin {tlacitko}
        drawbutton (a, true);
        klav := getkey;
      end
      else begin {inputline}
        exit_key := #0;
        with aktip[a]^ do cti (vstup_ptr, x, y, fyz_max, virt_max,
	                       allowed_key_list, disallowed_key_list);
        if exit_key = #27 then konec := true;
        if (exit_key = #13) and (from_cti_to_next_allow) then
          exit_key := #9;
        klav := exit_key;
      end;
       
      prev := a;
     

      {uzivatel zada zruseni formulare}
      if klav = #27 then begin
        exit_key := #27;
        konec := true;
      end;
      {uzivatel konci formular potvrzenim tlacitka}
      if klav = #13 then begin
        exit_key := #13;
        runaktip := a;
        konec := true;
      end;
       
      {dalsi prvek}
      if (klav = #191) or (klav = #192) or (klav = #9) then begin
        inc (a);
        if a >= poc_aktip then a := 0; 
      end;
      {predchozi prvek}
      if (klav = #189) or (klav = #190) then begin
        if a > 0 then dec (a)
        else a := poc_aktip - 1;
      end;

      {testujeme exit_key_list}
      for b := 1 to length (exit_key_list) do
        if (klav = exit_key_list [b]) then begin
          exit_key := klav;
          konec := true;
        end;
    until konec; 
  end;
end;

procedure setexitkey (ret :string);
begin
  exit_key_list := ret;
end;

procedure setallowedkey (ret: string);
begin
  allowed_key_list := ret;
end;
  
procedure setdisallowedkey (ret: string);
begin
  disallowed_key_list := ret;
end;
  
procedure setfromctitonextallow (p :boolean);
begin
  from_cti_to_next_allow := p;  
end;



procedure setbuttondecoration (l, p :char);
begin
  bl := l;
  bp := p;  
end;

procedure setbuttoncolor (pfg, pbg, afg, abg :byte);
begin
  bpfg := pfg;
  bpbg := pbg;  
  bafg := afg;
  babg := abg;  
end;

procedure setinputlinecolor (pfg, pbg, afg, abg :byte);
begin
  ipfg := pfg;
  ipbg := pbg;  
  iafg := afg;
  iabg := abg;  
end;

{MENU}
procedure justifynewmenuitem (pml :pmenu_list);
var
  width, next_width :byte;
  a :byte;
begin
  {upravim sirku menu}
  with pml^ do begin
    {pridame okraje k nove polozce}
    item[count-1].title := ' ' + item[count-1].title + ' ';
    item[count-1].hint := item[count-1].hint + ' ';
    {roztahneme menu na sirku nejdelsi polozky}
    if count > 1 then begin
       {zjistim novou sirku}
       width := length (item[0].title) + length (item[0].hint);
       next_width := length(item[count-1].title)+length(item[count-1].hint);
       if next_width > width then width := next_width;
       {roztahnu menu na novou sirku}
       for a := 0 to count-1 do
         while length (item[a].title) + length (item[a].hint) < width do
             item[a].title := item[a].title + ' ';
    end;
    
  end;
end;

procedure menuitem (var pml :pmenu_list; title :string[64]; hint :string[5];
                    action :tmenu_akce);
begin
  {naalokujeme nove menu}
  if pml = nil then begin
    new (pml);
    pml^.count := 0;
  end;
  {pridam novou polozku}
  with pml^ do begin
    item[count].title := title;
    item[count].hint := hint;
    item[count].action := action;
    item[count].psubmenu_list := nil;
    inc (count);
  end;
  {roztahnu menu}
  justifynewmenuitem (pml);
end;

function submenu (var pml :pmenu_list; title :string[64]): pmenu_list;
begin
  {naalokujeme nove menu}
  if pml = nil then begin
    new (pml);
    pml^.count := 0;
  end;
  {pridam novou polozku - submenu}
  with pml^ do begin
    item[count].title := title;
    item[count].hint := '>>';
    new (item[count].psubmenu_list);{naalokuji submenu a jeho pointer vraci fce}
    item[count].psubmenu_list^.count := 0;
    submenu := item[count].psubmenu_list;
    inc (count);
  end;
  {roztahnu menu}
  justifynewmenuitem (pml);
end;

procedure freemenu (var pml :pmenu_list);
var
  a :byte;
begin
  if pml <> nil then begin
    with pml^ do
      for a := 0 to count - 1  do 
        if item[a].psubmenu_list <> nil then freemenu (item[a].psubmenu_list);
    dispose (pml);
  end;
end;

function runmenu (mlist :pmenu_list; start :byte) :boolean;
var
  a, okno, b :byte;
  width, height :byte;
  akt, prev :byte;
  konec :boolean;
  klav :char;
begin
  with mlist^ do begin
    {vytvorim okno}
    width := length (item[0].title) + length (item[0].hint);
    height := count;
    swsize (nid, width, height);
    swcenter (nid);
    swtitle (nid, '');
    openwindow (okno);
 
    {zobrazim menu}
    for a := 0 to count - 1 do begin
      wjdina (0, a);
      barva (mptfg, mpbg);
      wpis (item[a].title);
      barva (mphfg, mpbg);
      wpis (item[a].hint);
    end;
    if start > count - 1 then start := count - 1;
    akt := start;
    prev := akt;
    konec := false;
    repeat
      {zhasneme predchozi}
      wjdina (0, prev);
      barva (mptfg, mpbg);
      wpis (item[prev].title);
      barva (mphfg, mpbg);
      wpis (item[prev].hint);
      {rozsvitime aktualni}
      wjdina (0, akt);
      barva (matfg, mabg);
      wpis (item[akt].title);
      barva (mahfg, mabg);
      wpis (item[akt].hint);
 
      prev := akt;
 
      klav := getkey;
 
      {rusime}
      if klav = #27 then begin
        exit_key := #27;
        runmenu := false;
        konec := true;
      end;
      {potvrzujeme}
      if klav = #13 then begin
        exit_key := #13;
        {normalni polozka}
        if (item[akt].psubmenu_list=nil) then begin
          if item[akt].action <> nil then begin
            item[akt].action;
            runmenu := true;
	    konec := true;
            changewindow (okno);
          end;
	end
        {nasleduje submenu}
        else begin 
          runmenu := false;
          konec := runmenu (item[akt].psubmenu_list, 0);
          {konec := true;}
	end;
      end;
 
      {dalsi prvek}
      if (klav = #191) or (klav = #192) or (klav = #9) then begin
        inc (akt);
        if akt >= count then akt := 0; 
      end;
      {predchozi prvek}
      if (klav = #189) or (klav = #190) then begin
        if akt > 0 then dec (akt)
        else akt := count - 1;
      end;
 
      {testujeme exit_key_list}
      {for b :=  1 to length (exit_key_list) do
        if (klav = exit_key_list [b]) then begin
          exit_key := klav;
          konec := true;
        end;}
    until konec;
    closewindow (okno);
  end;
end;

procedure setmenucolor (ptfg, phfg, pbg, atfg, ahfg, abg :byte);
begin
  mptfg := ptfg;
  mphfg := phfg;
  mpbg := pbg;
  matfg := atfg;
  mahfg := ahfg;
  mabg := abg;
end;

end.


